//+------------------------------------------------------------------+ 
//|T3 SATL.mq4 
//| 
//+------------------------------------------------------------------+ 
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen      
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_width1  2      
#property indicator_width2  2
#property indicator_width3  2         

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    T3Period        = 8;
extern double T3Hot           = 0.7;
extern bool   T3Original      = false;
extern bool   MultiColor      = true;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double satl[]; 
double satlDa[]; 
double satlDb[];
double trend[]; 

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init() 
{ 
   IndicatorBuffers(4);
   SetIndexBuffer(0,satl); 
   SetIndexBuffer(1,satlDa);
   SetIndexBuffer(2,satlDb); 
   SetIndexBuffer(3,trend);  
   
   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  Satl");
   return(0);
  }

//+------------------------------------------------------------------+ 
//| 
//+------------------------------------------------------------------+ 
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { satl[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if(calculateValue || timeFrame==Period())
   {
   if(MultiColor && !calculateValue && trend[limit]==-1) CleanPoint(limit,satlDa,satlDb);
   
       for(i=limit; i>=0; i--)
       {
        double value = 
0.0982862174*Close[i+0] 
+0.0975682269*Close[i+1] 
+0.0961401078*Close[i+2] 
+0.0940230544*Close[i+3] 
+0.0912437090*Close[i+4] 
+0.0878391006*Close[i+5] 
+0.0838544303*Close[i+6] 
+0.0793406350*Close[i+7] 
+0.0743569346*Close[i+8] 
+0.0689666682*Close[i+9] 
+0.0632381578*Close[i+10] 
+0.0572428925*Close[i+11] 
+0.0510534242*Close[i+12] 
+0.0447468229*Close[i+13] 
+0.0383959950*Close[i+14] 
+0.0320735368*Close[i+15] 
+0.0258537721*Close[i+16] 
+0.0198005183*Close[i+17] 
+0.0139807863*Close[i+18] 
+0.0084512448*Close[i+19] 
+0.0032639979*Close[i+20] 
-0.0015350359*Close[i+21] 
-0.0059060082*Close[i+22] 
-0.0098190256*Close[i+23] 
-0.0132507215*Close[i+24] 
-0.0161875265*Close[i+25] 
-0.0186164872*Close[i+26] 
-0.0205446727*Close[i+27] 
-0.0219739146*Close[i+28] 
-0.0229204861*Close[i+29] 
-0.0234080863*Close[i+30] 
-0.0234566315*Close[i+31] 
-0.0231017777*Close[i+32] 
-0.0223796900*Close[i+33] 
-0.0213300463*Close[i+34] 
-0.0199924534*Close[i+35] 
-0.0184126992*Close[i+36] 
-0.0166377699*Close[i+37] 
-0.0147139428*Close[i+38] 
-0.0126796776*Close[i+39] 
-0.0105938331*Close[i+40] 
-0.0084736770*Close[i+41] 
-0.0063841850*Close[i+42] 
-0.0043466731*Close[i+43] 
-0.0023956944*Close[i+44] 
-0.0005535180*Close[i+45] 
+0.0011421469*Close[i+46] 
+0.0026845693*Close[i+47] 
+0.0040471369*Close[i+48] 
+0.0052380201*Close[i+49] 
+0.0062194591*Close[i+50] 
+0.0070340085*Close[i+51] 
+0.0076266453*Close[i+52] 
+0.0080376628*Close[i+53] 
+0.0083037666*Close[i+54] 
+0.0083694798*Close[i+55] 
+0.0082901022*Close[i+56] 
+0.0080741359*Close[i+57] 
+0.0077543820*Close[i+58] 
+0.0073260526*Close[i+59] 
+0.0068163569*Close[i+60] 
+0.0062325477*Close[i+61] 
+0.0056078229*Close[i+62] 
+0.0049516078*Close[i+63] 
+0.0161380976*Close[i+64]; 

    satl[i]   = iT3(value,T3Period,T3Hot,T3Original,i);
    satlDa[i] = EMPTY_VALUE;
    satlDb[i] = EMPTY_VALUE;
    trend[i]  = trend[i+1];
    
    if (satl[i] > satl[i+1]) trend[i]=  1;
    if (satl[i] < satl[i+1]) trend[i]= -1;   
    if (MultiColor && !calculateValue && trend[i]==-1) PlotPoint(i,satlDa,satlDb,satl);
    }
          
    manageAlerts();           
    return (0);
    } 
    
    //
    //
    //
    //
    //
   
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (MultiColor && trend[limit]==-1) CleanPoint(limit,satlDa,satlDb);

        for (i=limit;i>=0; i--)
        {
             int y   = iBarShift(NULL,timeFrame,Time[i]);
             satl[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Hot,T3Original,0,y);
             satlDa[i] = EMPTY_VALUE;
             satlDb[i] = EMPTY_VALUE;
             trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Hot,T3Original,3,y);
             
        }
        
        if (MultiColor) for (i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,satlDa,satlDb,satl);
    manageAlerts(); 
   
 return(0);
} 

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Satl changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Satl "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
  
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
                                                      
//
//
//
//
//

}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

